<?php
namespace Elementor;

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}

class Elementor_CornerAd_Widget extends Widget_Base
{
	public function get_name()
	{
		return 'search-in-place';
	} // End get_name

	public function get_title()
	{
		return 'Search in Place';
	} // End get_title

	public function get_icon()
	{
		return 'fa fa-search ';
	} // End get_icon

	public function get_categories()
	{
		return array( 'search-in-place-cat' );
	} // End get_categories

	public function is_reload_preview_required()
	{
		return false;
	} // End is_reload_preview_required

	protected function _register_controls()
	{
		$this->start_controls_section(
			'search_in_place_section',
			array(
				'label' => __( 'Search in Place', 'search-in-place' )
			)
		);

		$this->end_controls_section();
	} // End _register_controls

	protected function render()
	{
		get_search_form(true);
	} // End render

	public function render_plain_content()
	{
		get_search_form(true);
	} // End render_plain_content

	protected function _content_template() {} // End _content_template
} // End Elementor_CornerAd_Widget

// Register the widgets
Plugin::instance()->widgets_manager->register_widget_type( new Elementor_CornerAd_Widget );
