<?php
/*
Widget Name: Search in Place Form
Description: Inserts a search form.
Documentation: https://wordpress.dwbooster.com/content-tools/search-in-place
*/

if(!class_exists('SiteOrigin_SearchInPlace'))
{
	class SiteOrigin_SearchInPlace extends SiteOrigin_Widget
	{
		function __construct()
		{
			parent::__construct(
				'siteorigin-search-in-place',
				__('Search In Place Form', 'search-in-place'),
				array(
					'description' 	=> __('Insert a search form', 'search-in-place'),
					'panels_groups' => array('search-in-place'),
					'help'        	=> 'https://wordpress.dwbooster.com/content-tools/search-in-place'
				),
				array(),
				array(),
				plugin_dir_path(__FILE__)
			);
		} // End __construct

		function get_template_name($instance)
		{
			return 'siteorigin-search-in-place';
		} // End get_template_name

		function get_style_name($instance)
		{
			return '';
		} // End get_style_name

	} // End Class SiteOrigin_SearchInPlace

	// Registering the widget
	siteorigin_widget_register('siteorigin-search-in-place', __FILE__, 'SiteOrigin_SearchInPlace');
}